VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "HttpClient"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

Public Referer$
Public UserAgent$
Public User$
Public Password$
Public Proxy$

Public Document$
Public Header$
Public ReturnValue%

Private HeaderFieldCollection As New Collection
Private WithEvents Socket As CSocket
Attribute Socket.VB_VarHelpID = -1
Private Const base64 = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/"

Private Sub Class_Initialize()
Set Socket = New CSocket
Referer$ = ""
UserAgent$ = ""
User$ = ""
Password$ = ""
Proxy$ = ""
Document$ = ""
Header$ = ""
ReturnValue% = 0
End Sub

Private Sub Class_Terminate()
Set Socket = Nothing
End Sub

Public Sub GetHtmlPage(url$)

ReturnValue% = 0
Document$ = ""
Do While HeaderFieldCollection.Count: HeaderFieldCollection.Remove 1: Loop

If LCase$(Left$(url$, 7)) = "http://" Then url$ = Mid$(url$, 8)
host$ = parse$(url$, "/")

If Len(Proxy$) Then contactHost$ = Proxy$ Else contactHost$ = host$

If InStr(contactHost$, ":") Then server$ = parse$(contactHost$, ":"): Port& = Val(contactHost$) Else server$ = contactHost$: Port& = 80
Socket.Connect server$, Port&
Do While Socket.State = sockConnecting: DoEvents: Loop
If Socket.State <> sockConnected Then Exit Sub

If Len(Proxy$) = 0 Then
   Socket.SendData "GET /" + url$ + " HTTP/1.0" + vbCrLf
Else
   Socket.SendData "GET http://" + host$ + "/" + url$ + " HTTP/1.0" + vbCrLf
End If

Socket.SendData "Host: " + host$ + vbCrLf
If Len(Referer$) Then Socket.SendData "Referer: " + Referer$ + vbCrLf
If Len(UserAgent$) Then Socket.SendData "User-Agent: " + UserAgent$ + vbCrLf
If Len(User$) > 0 And Len(Password$) > 0 Then Socket.SendData "Authorization: Basic " + base64_encode$(User$ + ":" + Password$) + vbCrLf
Socket.SendData vbCrLf

Do While Socket.State = sockConnected: DoEvents: Loop

Header$ = ""
Do While Len(Document$)
   line$ = parse$(Document$, vbCrLf): If line$ = "" Then Exit Sub
   Header$ = Header$ + line$ + vbCrLf
   If ReturnValue = 0 Then ReturnValue = Val(Mid$(line$, InStr(line$, " ") + 1))
   If InStr(line$, ":") Then HeaderFieldCollection.Add Trim$(Mid$(line$, InStr(line$, ":") + 1)), Left$(line$, InStr(line$, ":") - 1)
Loop

End Sub

Public Function HeaderField$(key$)

HeaderField$ = ""
On Error Resume Next
HeaderField$ = HeaderFieldCollection(key$)

End Function

Private Function parse$(a$, ch$)
ai% = InStr(a$, ch$)
If ai% = 0 Then
  parse$ = a$: a$ = ""
Else
  parse$ = Left$(a$, ai% - 1): a$ = Mid$(a$, ai% + Len(ch$))
End If
End Function

Private Function base64_encode$(a$)
c$ = ""
For n% = 1 To Len(a$) Step 3
   c1% = Asc(Mid$(a$, n%, 1))
   c2% = Asc(Mid$(a$, n% + 1, 1) + Chr$(0))
   c3% = Asc(Mid$(a$, n% + 2, 1) + Chr$(0))
   w1% = Int(c1% / 4)
   w2% = (c1% And 3) * 16 + Int(c2% / 16)
   If Len(a$) >= n% + 1 Then w3% = (c2% And 15) * 4 + Int(c3% / 64) Else w3% = -1
   If Len(a$) >= n% + 2 Then w4% = c3% And 63 Else w4% = -1
   If w1% >= 0 Then c$ = c$ + Mid$(base64, w1% + 1, 1) Else c$ = c$ + "="
   If w2% >= 0 Then c$ = c$ + Mid$(base64, w2% + 1, 1) Else c$ = c$ + "="
   If w3% >= 0 Then c$ = c$ + Mid$(base64, w3% + 1, 1) Else c$ = c$ + "="
   If w4% >= 0 Then c$ = c$ + Mid$(base64, w4% + 1, 1) Else c$ = c$ + "="
Next
base64_encode$ = c$
End Function

Private Sub Socket_Closed()
Socket.Disconnect
End Sub

Private Sub Socket_DataArrival(BinData() As Byte, RemoteHostIP As String)
Document$ = Document$ + StrConv(BinData, vbUnicode)
End Sub
